/**
* @file  file_display_grafics.h
* @brief Schnittstelle fuer die Klasse FileDisplayGrafics.
*/
//////////////////////////////////////////////////////////////////////
#pragma once
#ifndef FILE_DISPLAY_GRAFICS_H
#define FILE_DISPLAY_GRAFICS_H

#ifdef _MSC_VER
#pragma warning(disable : 4996)
#endif

// Verwaltungsklasse fuer Datei
#include "file_intel_hex.h"

// Strukturdefinitionen
#include "interface/display_grafics_structs.h"

#include <array>

class FileDisplayGrafics : public FileIntelHex
{
public:
    FileDisplayGrafics();
    virtual ~FileDisplayGrafics();

public:
    void resetData();

public:
    enum { max_grafic_count = 250 };
    // Verwaltungsstrukturen fuer Grafik
    GRAFICNODE *m_pGraficNode;
    std::array<GRAFIC *, max_grafic_count> m_pGrafic;

public:
    bool load( const std::string &filePath );
    bool save( const std::string &filePath, bool appendToFile = false, bool appendEndLine = true );

    void Default( unsigned char count );
    void setSizeData( std::size_t size );

protected:
    bool loadBin( std::ifstream &fs, std::size_t size );
    bool saveBin( std::ofstream &fs );
};

#endif

