#include "file/interface/dfitem/dfitem_input_chain_field.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemInputChainField::CDFItemInputChainField( tinyxml2::XMLDocument *doc ) : CDFItemBase( doc )
{
    xmlElement()->SetText( "ItemInputChainField" );
}

CDFItemInputChainField::~CDFItemInputChainField()
{

}

int CDFItemInputChainField::Modify( CModifyData &modifyData )
{
    // Daten von FeldEinlesen einlesen
    StructReadField &feldEinlesen = *(StructReadField *)&modifyData.file->m_flash[modifyData.offsFlash - FLASH_KONFIG_START];
    StructTextEx exText;
    StructConfirmationEx exBestaetigung;
    StructNumFieldEx exNumFeld;
    StructListSelectionEx exListAuswahl;
    StructDataEx exData;
    StructGlobVarToHIDEx exGVToHID;
    StructSwitchModuleEnergieEx switchModuleEnergie;

    // Name aendern?
    strcpy( feldEinlesen.name, LookupReplace( modifyData, feldEinlesen.name ).c_str() );

    // Daten fuer union je nach "Einlesemethode"
    switch ( feldEinlesen.type )
    {
        case TBFE_NORM:
        case TBFE_GET_TIME:
        case TBFE_KONSTANTE:
        case TBFE_COPY_GV_TO_FIELD:
        case TBFE_TIMEBOY_COPY_GV_TO_FIELD:
        case TBFE_SERIENNUMMER:
        case TBFE_ANALOG_WERT:
        case TBFE_ANALOG_STATUS:
        case TBFE_DIGITAL_WERT:
        case TBFE_ZAEHLER_WERT:
        case TBFE_FUNC:
        case TBFE_SPS_WERT:
        case TBFE_ENTRANCE_ZM_NUM:
        case TBFE_ENTRANCE_READER_NUM:
        case TBFE_ENTRANCE_PNR:
        case TBFE_ENTRANCE_STATUS:
        case TBFE_DEBUG:
        case TBFE_GPRS_ALIVE_COUNTER:
        case TBFE_FIRMWARE_VERSION:
        case TBFE_ONLINE_STATUS:
        case TBFE_SUMMER_WINTER_STATUS:
        case TBFE_GPS_RECORD_FIX:
        case TBFE_GPS_RECORD_VARIABLE:
        case TBFE_ENTRANCE2_IDENTIFICATION:
        case TBFE_COPY_FIELD_TO_GV:
        case TBFE_TIMEBOY_COPY_FIELD_TO_GV:
        case TBFE_FINGERPRINT_SCANN:
        case TBFE_FINGERPRINT_CARD:
        case TBFE_FINGERPRINT_TEACH:
        case TBFE_FINGERPRINT_IDENTIFICATION:
        case TBFE_FINGERPRINT_VERIFICATION:
        case TBFE_FINGERPRINT_DELETE:
        case TBFE_OPERATION:
        case TBFE_SWITCH_RELAY:
        case TBFE_SWITCH_LED:
        case TBFE_TIMER:
        case TBFE_TRANSPONDER_WRITE:
        case TBFE_GPS_DISTANCE:
        case TBFE_MOBILE_PARAMETER:
        case TBFE_SWITCH_BUZZER:
        case TBFE_KONSTANTE_TYPE_DEVICE_NAME:
        case TBFE_MOBILMASTERIV_MENUENTRY:
        case TBFE_SWITCH_COMMUNICATION:
        case TBFE_TIMER_STATE:
        case TBFE_VIBRATION_VALUE:
        case TBFE_FINGERPRINT_ADMNISTARTION:

            exNumFeld = feldEinlesen.ex.numField;
            break;

        case TBFE_LIST_SELECT_GET:
        case TBFE_LIST_SELECT_SET:

            exListAuswahl = feldEinlesen.ex.listSelection;
            break;

        case TBFE_BESTAETIGUNG:

            exBestaetigung = feldEinlesen.ex.confirmation;
            break;

        case TBFE_SEND_SMS:
        case TBFE_SCRIPT:
        case TBFE_SHOW_MESSAGE:
        case TBFE_READ_VARIABLE:
        case TBFE_WRITE_VARIABLE:

            exText = feldEinlesen.ex.text;
            break;

        case TBFE_SWITCH_BACKLIGHT:

            exData = feldEinlesen.ex.data;
            break;

        case TBFE_GV_TO_INTERFACE:

            exGVToHID = feldEinlesen.ex.globVarToHID;
            break;

        case TBFE_SWITCH_MODULE_ENERGIE:   // Energiezustand eines Moduls einstellen.

            switchModuleEnergie = feldEinlesen.ex.switchModuleEnergie;
            break;
    }


    return 1;
}
